﻿import es
import gamethread
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

common = langlib.Strings(lang_dir + "common.ini")
messages = langlib.Strings(lang_dir + "cap/messages_cap_pick.ini")
messages_common = langlib.Strings(lang_dir + "messages_common.ini")

# ******************** Events ********************
def player_death(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			es.set("sm_cap_winner_userid", event_var["attacker"])
			es.set("sm_cap_loser_userid", event_var["userid"])

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			es.set("sm_cap_winner_pick", 1)
			es.set("sm_cap_winner_number", 5)
			es.set("sm_cap_loser_number", 5)

			myPlayerList = playerlib.getPlayerList("#human,#spec")
			if len(myPlayerList) > 0:
				tokens = {}
				tokens["command"] = es.ServerVar("sm_cap_command_pick")

				userid = es.ServerVar("sm_cap_winner_userid")
				if userid > 1:
					send_pick_menu(userid)

					player = playerlib.getPlayer(userid)
					es.tell(userid, "#green", messages("pick_command", tokens, player.get("lang")))

				userid = es.ServerVar("sm_cap_loser_userid")
				if userid > 1:
					player = playerlib.getPlayer(userid)
					es.tell(userid, "#green", messages("pick_command", tokens, player.get("lang")))

			es.doblock("soccer_mod_2010/cap/load_variables")

# ******************** Commands ********************
def cmd_pick():
	tokens = {}
	userid = int(es.getcmduserid())
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		winnerid = int(es.ServerVar("sm_cap_winner_userid"))
		loserid = int(es.ServerVar("sm_cap_loser_userid"))
		pick = int(es.ServerVar("sm_cap_winner_pick"))

		if winnerid == userid:
			if pick == 1:
				if int(es.ServerVar("sm_cap_winner_number")) > 0:
					send_pick_menu(winnerid)
				else:
					es.tell(userid, "#green", messages("cant_pick_anymore", tokens, player.get("lang")))
			else:
				es.tell(userid, "#green", messages("not_your_turn", tokens, player.get("lang")))
		elif loserid == userid:
			if pick == 0:
				if int(es.ServerVar("sm_cap_loser_number")) > 0:
					send_pick_menu(loserid)
				else:
					es.tell(userid, "#green", messages("cant_pick_anymore", tokens, player.get("lang")))
			else:
				es.tell(userid, "#green", messages("not_your_turn", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("not_cap", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def send_pick_menu(userid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	myPlayerList = playerlib.getPlayerList("#human,#spec")
	if len(myPlayerList) > 0:
		myPopup = popuplib.easymenu(name, None, pick)
		myPopup.settitle(messages("select_player"))

		for player in playerlib.getPlayerList("#human,#spec"):
			myPopup.addoption(player.userid, player.name)

		popuplib.send(name, userid)

def lang_msg(text, tokens, center = 0):
	for player in playerlib.getPlayerList("#human"):
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def pick(userid, choice, keymenuname):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if es.exists("userid", choice) == 1:
		es.server.queuecmd("es_changeteam %s %s" % (choice, es.getplayerteam(userid)))

		tokens = {}
		tokens["name"] = es.getplayername(userid)
		tokens["target"] = es.getplayername(choice)
		lang_msg("pick", tokens)

		winner_number = es.ServerVar("sm_cap_winner_number")
		loser_number = es.ServerVar("sm_cap_loser_number")

		if winner_number > 0 and loser_number > 0:
			if es.ServerVar("sm_cap_winner_pick") == 1:
				userid = es.ServerVar("sm_cap_loser_userid")

				es.set("sm_cap_winner_pick", 0)

				winner_number -= 1
				es.set("sm_cap_winner_number", winner_number)
			else:
				userid = es.ServerVar("sm_cap_winner_userid")

				es.set("sm_cap_winner_pick", 1)

				loser_number -= 1
				es.set("sm_cap_loser_number", loser_number)

			gamethread.delayed(0.1, send_pick_menu, (userid))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", tokens, player.get("lang")))

		send_pick_menu(userid)